##### ansi.pl by sm- ####################################################
# ##################################################################### #
# this is a  pretty  basic ansi parser for  xchat. it ignores  all ansi	#
# codes except for color codes (m). i'm sure it could be optimized more #
# than it is currently, but i'm pretty new to perl. this will parse any #
# channel messages coming through and replace the ansi codes with XChat #
# color codes. you'll  want to use the palette included with infested/x #
# or you'll get some pretty weird looking colors.			#
#									#
# if you wanna use it in your own script for whatever reason, go ahead, #
# just give me credit :)						#
#									#
# sm- on EFnet (#demonic)						#
# essemm7@kracked.com							#
#########################################################################

# /ansi will parse anything you pass to it and echo it to the screen
IRC::add_command_handler("ansi", "inf_ansi");

# this parses all messages from the channel
IRC::add_print_handler("Channel Message", "inf_chanMsg");

# /count will display 80 characters to the screen so you can set your xchat
# width appropriately 
# NOTE: using the VGA font, xchat requires a width of 775 pixels
IRC::add_command_handler("count", "inf_count");

$boldOn = 0;

$ans_reset = 0;
$ans_bold = 1;
$ans_underline = 4;

$ans_black = 30;	$ans_Bblack = 40;
$ans_red = 31;		$ans_Bred = 41;
$ans_green = 32;	$ans_Bgreen = 42;
$ans_yellow = 33;	$ans_Byellow = 43;
$ans_blue = 34;		$ans_Bblue = 44;
$ans_magenta = 35;	$ans_Bmagenta = 45;
$ans_cyan = 36;		$ans_Bcyan = 46;
$ans_white = 37;	$ans_Bwhite = 47;

$curCode = "";
$curBG = "";

sub inf_ansColor {
  if ($_[0] eq $ans_reset) { 
    $boldOn = 0;
    $curCode = $ans_white;
    return "%C07,00";
  }
  elsif ($_[0] eq $ans_bold) { 
    $boldOn = 1;
    if ($curCode eq $ans_black) { return "%C08,$curBG"; }
    elsif ($curCode eq $ans_blue) { return "%C09,$curBG"; }
    elsif ($curCode eq $ans_green) { return "%C10,$curBG"; }
    elsif ($curCode eq $ans_cyan) { return "%C11,$curBG"; }
    elsif ($curCode eq $ans_red) { return "%C12,$curBG"; }
    elsif ($curCode eq $ans_magenta) { return "%C13,$curBG"; }
    elsif ($curCode eq $ans_yellow) { return "%C14,$curBG"; }
    elsif ($curCode eq $ans_white) { return "%C15,$curBG"; }
  }
  elsif ($_[0] eq $ans_underline) { return "%U"; }
  elsif ($_[0] eq $ans_Bblack) { $curBG = "00"; return "%C,00"; }
  elsif ($_[0] eq $ans_Bblue) { $curBG = "01"; return "%C,01"; }
  elsif ($_[0] eq $ans_Bgreen) { $curBG = "02"; return "%C,02"; }
  elsif ($_[0] eq $ans_Bcyan) { $curBG = "03"; return "%C,03"; }
  elsif ($_[0] eq $ans_Bred) { $curBG = "04"; return "%C,04"; }
  elsif ($_[0] eq $ans_Bmagenta) { $curBG = "05"; return "%C,05"; }
  elsif ($_[0] eq $ans_Byellow) { $curBG = "06"; return "%C,06"; }
  elsif ($_[0] eq $ans_Bwhite) { $curBG = "07"; return "%C,07"; }
  elsif ($boldOn eq 0) {
    $curCode = $_[0];
    if ($_[0] eq $ans_black) { return "%C00,$curBG"; }
    elsif ($_[0] eq $ans_blue) { return "%C01,$curBG"; }
    elsif ($_[0] eq $ans_green) { return "%C02,$curBG"; }
    elsif ($_[0] eq $ans_cyan) { return "%C03,$curBG"; }
    elsif ($_[0] eq $ans_red) { return "%C04,$curBG"; }
    elsif ($_[0] eq $ans_magenta) { return "%C05,$curBG"; }
    elsif ($_[0] eq $ans_yellow) { return "%C06,$curBG"; }
    elsif ($_[0] eq $ans_white) { return "%C07,$curBG"; }
  } elsif ($boldOn eq 1) {
    $curCode = $_[0];
    if ($_[0] eq $ans_black) { return "%C08,$curBG"; }
    elsif ($_[0] eq $ans_blue) { return "%C09,$curBG"; }
    elsif ($_[0] eq $ans_green) { return "%C10,$curBG"; }
    elsif ($_[0] eq $ans_cyan) { return "%C11,$curBG"; }
    elsif ($_[0] eq $ans_red) { return "%C12,$curBG"; }
    elsif ($_[0] eq $ans_magenta) { return "%C13,$curBG"; }
    elsif ($_[0] eq $ans_yellow) { return "%C14,$curBG"; }
    elsif ($_[0] eq $ans_white) { return "%C15,$curBG"; }
  }
}

sub inf_ansi {
  $oldString = $_[0];
  $newString = "";
  $code = "";
  $i = 0;
  $boldOn = 0;
  $curBG = "00";
  do {
    if (substr($oldString,$i,2) eq "\033[") {
      $codeStart = $i;
      $ansiDone = 0;
      do {
        $code = $code . substr($oldString,$i,1);
        $i++;
        if (substr($oldString,$i,1) eq "m") { $ansiDone = 1; }
	elsif ($i > length($oldString)) {
	  $ansiDone = 1;
	  $code = "NA";
	}
      } until $ansiDone == 1;
      if ($code eq "NA") {
	$i = $codeStart + 2;
	$newString = $newString . "\033[";
      } else {
        $code = substr($code,2,length($code)-2);
        @codes = split(/;/,$code);
        $b = 0;
        do {
          $newString = $newString . inf_ansColor($codes[$b]);
          $b++;
        } while ($codes[$b]);
      }
    } else {
      $newString = $newString . substr($oldString,$i,1);
    }
    $code = "";
    $i++;
  } while ($i < length($oldString));
  return $newString;
}

sub inf_chanMsg {
  @stuff = split(/ /,$_[0]);
  $nick = $stuff[1];
  $chanMsg = substr($_[0],length($nick)+1,length($_[0])-length($nick)+1);
  $chanMsg = inf_ansi($chanMsg);
  IRC::command("/echo %C08<%C07$nick%C08>%C07$chanMsg");
}

sub inf_count {
  $countStr = "";
  $i = 0;
  do {
    $countStr = $countStr . "X";
    $i++;
  } until ($i > 80);
  IRC::command("/echo $countStr");
  return 1;
}

IRC::command("/echo %C05ansi.pl loaded");
